//1
import {select, csv, scaleLinear, max, scaleBand, axisLeft, axisBottom, format} from 'd3';
//2
const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

// 4: afunction to make rectangles for each ele in data-array
const render = data => {
  //value exercisers?
  const xValue = d => d.population;
  const yValue = d => d.country;
  //6: margin
  const margin = {top:40, bottom:80, right:40, left:200};
  //7: innners; making room for axes
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  //5:creating scales, instances of scaleLinear, function of d3
  const xScale = scaleLinear()
  	.domain([0, max(data, xValue)])
  //checking
  //console.log(xScale.domain())
  	.range([0, innerWidth]);
  
  
  const yScale = scaleBand()
  	.domain(data.map(yValue))
  	.range([0,innerHeight])
  	.padding(0.1);
    
  
  //6: margin
  const g = svg.append('g')
  	.attr('transform', `translate(${margin.left}, ${margin.top})`);
  
  //9:define xaxis to avoid messy code
  const xAxis = axisBottom(xScale)
  	.tickFormat(format('.3s'))
  	.tickSize(-innerHeight);
  
  //8b:
  g.append('g')
    .call(axisLeft(yScale))
  	.selectAll('.domain, .tick line')
  		.remove();
  
  const xAxisG = g.append('g').call(xAxis)
  	.attr('transform', `translate(0, ${innerHeight})`);
  	
  xAxisG.select('.domain').remove();
  
  xAxisG.append('text')
  	.attr('class', 'axis-label')
  	.attr('y', 60)
  	.attr('x', innerWidth/2)
  	.attr('fill', 'black')
		.text('Population');
  
  
  //2 or 3 //6: append to g rahter than svg
  g.selectAll('rect').data(data)
  	.enter().append('rect')
  		.attr('y', d => yScale(yValue(d)))
  		.attr('width', d => xScale(xValue(d)))
  		.attr('height', yScale.bandwidth())

	g.append('text')
  	.attr('class', 'title')
  	.attr('y', -5)
		.text('Top 10 Most Populous Countries');


};

// 3: a path for a function csv of d3; returns a promise, so we THEN pass that to a function that returns an array
csv('data.csv').then(data =>{
  //to check for the data
  //console.log(data); need to convert strings to numbers
  data.forEach(d => {
    d.population = +d.population*1000;
  });
  //console.log(data)
  render(data);
})
